#include <SPI.h>

//シフトレジスタのピンはこのように接続する
#define RCK 9    //LE へ
#define SCK 13   //CLKへ
#define MOSI 11  //SDIへ

void setup(){
  pinMode(RCK, OUTPUT);
  pinMode(SCK, OUTPUT);
  pinMode(MOSI, OUTPUT);
  pinMode(14, OUTPUT);
  
  //ハードウェアSPIを使用する
//  bitSet(TIMSK2, TOIE2);
  SPI.begin();
  SPI.setBitOrder(MSBFIRST);
  SPI.setClockDivider(SPI_CLOCK_DIV64);
  SPI.setDataMode(SPI_MODE0);
}

void loop(){

  //1つづつ順番に点灯
  slide(2);  
  
  //1つづつ全部点灯
  barUP();
  
  
  //好きな場所を点灯
  segPrint(0b00000000, 0b00001000);
  delay(1000);

}


//16bit シフト
void bit16sift(char *val1, char *val2){
  if(*val1 & 0x80) *val2 = 1;
  else *val2<<=1;
  *val1<<=1;
}

//1つづつ全部点灯
void barUP(){
  char val1 = 1;
  char val2 = 0;
  char view1 = 1;
  char view2 = 0;
  
  for(int j=0; j<16; j++){
    segPrint(view2, view1);
    bit16sift(&val1, &val2);
    view1 |= val1;
    view2 |= val2;
      
    delay(200);
  }
}

//1つづつ順番に点灯
void slide(int time){
  char val1 = 1;
  char val2 = 0;
  
  for(int i=0; i<time; i++){
    for(int j=0; j<16; j++){
      segPrint(val2, val1);
      if(val2 & 0x80){ val1=1; val2 = 0; }
      else bit16sift(&val1, &val2);
    
      delay(200);
    }
  }
}


//ハードウェアSPIを使ってシリアル転送
void segPrint(char val1, char val2){
  digitalWrite(RCK, LOW);
  SPI.transfer(val1);    //余分に1個分転送している
  SPI.transfer(val2);
  SPI.transfer(val1);
  SPI.transfer(val2);
  digitalWrite(RCK, HIGH);
}

//タイマオーバーフロー割り込みを設定
//ISR(TIMER2_OVF_vect){
//  update();
//}
